/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package bebop.lib;

public class BebopAddress {
	
	private String host;
	private int port;
	private String mailbox;
	
	public BebopAddress(String address) {
		if (address.startsWith("bebop://")) {
			address = address.replace("bebop://", "");
			if (address.contains(":")) {
				String[] splitted = address.split(":");
				host = splitted[0];
				splitted = splitted[1].split("/");
				port = Integer.parseInt(splitted[0]);
				mailbox = splitted[1];
			} else {
				String[] splitted = address.split("/");
				host = splitted[0];
				mailbox = splitted[1];
			}
		}
	}
	
	public String getHost() {
		return host;
	}
	
	public String getMailbox() {
		return mailbox;
	}
	
	public int getPort() {
		return port;
	}
	
	public String toString() {
		return String.format("bebop://%s:%d/%s", host, port, mailbox);
	}

}
