/**
 *  BeBop Asynchronous Communication Library
 *  
 *  Copyright (C) 2008  Amos Brocco <amos.brocco@unifr.ch>
 *  					Pervasive and Artificial Intelligence Research Group
 *  					Department of Informatics DIUF
 *  					University of Fribourg, Fribourg
 *  					Switzerland
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package bebop.lib;

import java.util.Map;

public class Message implements IMessage {

	private BebopAddress recipient;
	private Map<String, Object> contents;

	public Message(String recipient, Map<String, Object> contents) {
		this.recipient = new BebopAddress(recipient);
		this.contents = contents;
	}
	
	public Message(BebopAddress recipient, Map<String, Object> contents) {
		this.recipient = recipient;
		this.contents = contents;
	}

	public BebopAddress getRecipient() {
		return recipient;
	}

	public Map<String, Object> getContents() {
		return contents;
	}

	public String toString() {
		return recipient.toString() + " ++ " + contents;
	}

}
