/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package cli;


public class StringOption implements IStringOption {
	
	private String description;
	private String shortLabel;
	private String longLabel;
	private String value;
	private String defaultValue;
	private boolean isMandatory;
	
	public StringOption(String shortL, String longL, String desc, String defValue, boolean mandatory) {
		shortLabel = shortL;
		longLabel = longL;
		defaultValue = defValue;
		description = desc;
		value = defaultValue;
		isMandatory = mandatory;
	}

	public String getDefault() {
		return defaultValue;
	}

	public String getDescription() {
		return description;
	}

	public String getLongLabel() {
		return longLabel;
	}

	public String getShortLabel() {
		return shortLabel;
	}

	public int getSkip() {
		return 2;
	}

	public void setValue(String string) {
		value = string;
	}

	public String getValue() {
		return value;
	}
	
	public boolean isMandatory() {
		return isMandatory;
	}

	public String getType() {
		return "string";
	}
	
	public boolean isValidValue(String value) {
		return value != null;
	}
	
	public boolean ignoreInvalid() {
		return false;
	}
}
