/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package cli;


public class SwitchOption implements ISwitchOption {
	
	private String description;
	private String shortLabel;
	private String longLabel;
	private boolean value;
	private boolean defaultValue;
	
	public SwitchOption(String shortL, String longL, String desc) {
		shortLabel = shortL;
		longLabel = longL;
		defaultValue = false;
		value = false;
		description = desc;
	}

	public String getDefault() {
		return new Boolean(defaultValue).toString();
	}

	public String getDescription() {
		return description;
	}

	public String getLongLabel() {
		return longLabel;
	}

	public String getShortLabel() {
		return shortLabel;
	}

	public int getSkip() {
		return 1;
	}

	public void setValue(String string) {
		value = true;
	}

	public Boolean getValue() {
		return value;
	}

	public boolean isMandatory() {
		return false;
	}
	
	public String getType() {
		return "n/a";
	}

	public boolean ignoreInvalid() {
		return true;
	}

	public boolean isValidValue(String value) {
		return true;
	}

}
