/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package core.vm.valuetypes;

import interfaces.vm.valuetypes.IReferenceValue;

public class ReferenceValue implements IReferenceValue {

	private static final long serialVersionUID = -2798422000018141117L;
	
	private String name;
	
	private Integer index;

	public ReferenceValue(String vname, Integer findex) {
		name = vname;
		index = findex;
	}
	
	//	 Bogus constructor for preloading
	public ReferenceValue() {
	}

	public String toString() {
		return name.toString();
	}

	public String getSignature() {
		return "@"+name;
	}

	public Object toBaseValue() {
		return this;
	}

	public boolean equals(Object string) {
		if (string instanceof ReferenceValue)
			return ((ReferenceValue) string).getSignature().equals(getSignature());
		else
			return false;
	}

	public int hashCode() {
		return getSignature().hashCode();
	}

	public String getReferencedName() {
		return name;
	}

	public Integer getFrameIndex() {
		return index;
	}

}
