/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package dot.codegenerator.modules;


import java.util.List;

import com.fuzzbug.solenopsis.sdk.lib.IConstants;
import com.fuzzbug.solenopsis.sdk.lib.IInstruction;


import logging.Logger;

import dot.codegenerator.ICodeGenerator;
import dot.codegenerator.Instruction;
import dot.parser.nodes.INode;

public class Dict_Generator implements IGenerator {

	ICodeGenerator cg;

	@SuppressWarnings("unchecked")
	public boolean generate(List programList, INode node) throws Exception {
		
		if (node.getChildCount() == 3) {
			for (int i=1; i< node.getChildCount(); i++)
				cg.generateCode(node.getChild(i));
		} else if (node.getChildCount() == 1) {
			Instruction constOp = new Instruction(IConstants.OPCODES.CONST, node);
			constOp.pushNil();
			programList.add(constOp);
			Instruction constOp2 = new Instruction(IConstants.OPCODES.CONST, node);
			constOp2.pushNil();
			programList.add(constOp2);
		} else {
			Logger.CompilerFatal(node, cg, "Missing values list in dictionary definition '%s'", node.getChild(1).getString());
		}
		
		IInstruction dictOp = new Instruction(IConstants.OPCODES.DICT, node);
		programList.add(dictOp);
		return false;
	}

	public String getIdentifier() {
		return "dict";
	}

	public void initialize(ICodeGenerator codegen) {
		cg = codegen;
	}

}
