/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package dot.lexer;

public class Constants {

	/* Token types */

	public static final int SYMBOL = 0;

	public static final int INTNUMBER = 1;

	public static final int FLOATNUMBER = 2;
	
	public static final int LONGNUMBER = 3;

	public static final int DOUBLENUMBER = 4;

	public static final int OPENBLOCK = 5;

	public static final int CLOSEBLOCK = 6;

	public static final int STRING = 7;

	public static final int QUOTE = 8;

	public static final int EOF = 9;

	public static final int PROGRAM = 10;
	
	public static final int BACKQUOTE = 11;
	
	public static final int COMMA = 12;
	
	public static final int AT = 13;
	
	public static final int DOT = 14;
	
	public static final int BACKSLASH = 15;
	
	public static final int CHAP = 16;
	
	public static final int CHECK = 17;
	
	public static final int CIRCLE = 18;
	
	public static final int OPENDICTBLOCK = 19;
	
	public static final int CLOSEDICTBLOCK = 20;
	
	public static final int OPENLISTBLOCK = 21;
	
	public static final int CLOSELISTBLOCK = 22;
	
	public static final int SEMICOLON = 23;
	
	public static final int PARA = 24;
	
}
