/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package dot.parser.nodes;

import java.util.ArrayList;


public interface INode {

	public void addChild(INode child);

	public INode getChild(int index) throws Exception;

	public int getChildCount();

	public int getType();
	
	public ArrayList<INode> getChildren();

	public String getString();
	
	public void setString(String string);

	public Number getNumber();

	public int getLine();

	public int getPosition();
	
	public void setParent(INode parent);
	
	public INode getParent();
	
	public void setCode(String code);
	
	public String getCode();
	
	public INode clone();
	
	public void replaceChild(int index, INode newchild);
	
	public void addChildAt(int index, INode child);
	
	public void removeChild(int index);

	public void setPosition(int originPosition);

	public void setLine(int originLine);

	public String getFilename();

}
