/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package exe;


import java.util.Hashtable;

import com.fuzzbug.solenopsis.sdk.exe.INodeDaemon;

import softthreading.IParallelScheduler;
import softthreading.ParallelScheduler;

public class PlatformDaemon {
	
	private IParallelScheduler 	scheduler = new ParallelScheduler();	
	private Hashtable<String, INodeDaemon> daemons = new Hashtable<String, INodeDaemon>();
	
	public void schedule(INodeDaemon d) {
		if (!daemons.containsKey(d.getIdentifier())) {
			daemons.put(d.getIdentifier(), d);
			scheduler.schedule(d);
		}
	}
	
	public void unschedule(INodeDaemon d) {
		daemons.remove(d.getIdentifier());
		d.stop();
		scheduler.unschedule(d);
	}
	
	public boolean runSimulation() {
		return scheduler.executeParallel();
	}


}
