package exe;

import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;

public class VMStats {
	
	private static Hashtable<String,Integer> executed = new Hashtable<String,Integer>();
	private static Hashtable<String,Integer> running = new Hashtable<String,Integer>();

	public static void stop(String sourcePath) {
		decrementRunning(sourcePath);
	}
	
	public static void start(String sourcePath) {
		incrementRunning(sourcePath);
	}
	
	private static void decrementRunning(String type) {
		synchronized(running) {
			Integer count = running.get(type);
			if (count != null) {
				count = count - 1;
				running.put(type, count);
			}
		}
	}
	
	private static void incrementRunning(String type) {
		synchronized(running) {
			incrementExecuted(type);
			Integer count = running.get(type);
			if (count == null) count = 0;
			count = count + 1;
			running.put(type, count);
		}
	}
	
	private static void incrementExecuted(String type) {
		synchronized(executed) {
			Integer count = executed.get(type);
			if (count == null) count = 0;
			count = count + 1;
			executed.put(type, count);
		}
	}
	
	public static Map<String,Object> getStats() {
		synchronized(running) {
			Map<String,Object> stats = new HashMap<String,Object>();
			for (String k : running.keySet()) {
				Map<String,Object> speciesStats = new HashMap<String,Object>();
				Integer count = running.get(k);
				Integer exec = executed.get(k);
				speciesStats.put("count", count);
				speciesStats.put("exec", exec);
				stats.put(k, speciesStats);
			}
			return stats;
		}
	}

}
