/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package interfaces.logging;

import java.io.PrintStream;

public interface ILoggingService {

	public static final int OFF = -1;

	public static final int SEVERE = 1;

	public static final int WARNING = 2;

	public static final int INFO = 3;

	public static final int FINE = 4;

	public static final int FINEST = 5;

	public static final int DEBUG = 6;

	public static final int ALL = 1000;

	public void log(int level, Object obj, String Message);

	public void log(int level, Object obj, String Message, Object... objects);

	public void log(Object obj, String Message);

	public void log(Object obj, String Message, Object... objects);

	public void log(String Message);

	public void log(String Message, Object... objects);

	public void log(int level, String Message);

	public void log(int level, String Message, Object... objects);

	public void addOutput(PrintStream output);

	public void setDefaultLevel(int level);

	public void removeOutput(PrintStream output);

	public void addOutput(int level, PrintStream output);

	public void removeAllOutputs();

}
