/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package logging;

import interfaces.logging.ILoggingService;

import java.io.PrintStream;


public class ExposedLogger implements ILoggingService {

	public void log(int level, Object obj, String Message) {
		StaticLogger.log(level, obj, Message);
	}

	public void log(int level, Object obj, String Message, Object... objects) {
		StaticLogger.log(level, obj, Message, objects);
	}

	public void log(Object obj, String Message) {
		StaticLogger.log(obj, Message);
	}

	public void log(Object obj, String Message, Object... objects) {
		StaticLogger.log(obj, Message, objects);
	}

	public void log(String Message) {
		StaticLogger.log(Message);
	}

	public void log(String Message, Object... objects) {
		StaticLogger.log(Message, objects);
	}

	public void log(int level, String Message) {
		StaticLogger.log(level, Message);
	}

	public void log(int level, String Message, Object... objects) {
		StaticLogger.log(level, Message, objects);
	}

	public synchronized void addOutput(PrintStream output) {
		StaticLogger.addOutput(output);
	}

	public synchronized void setDefaultLevel(int level) {
		StaticLogger.setDefaultLevel(level);
	}

	public synchronized void removeOutput(PrintStream output) {
		StaticLogger.removeOutput(output);
	}

	public synchronized void removeAllOutputs() {
		StaticLogger.removeAllOutputs();
	}

	public synchronized void addOutput(int level, PrintStream output) {
		StaticLogger.addOutput(level, output);
	}

}
