/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package opt.blatant;


import java.util.List;

import com.fuzzbug.solenopsis.sdk.exe.INodeDaemon;
import com.fuzzbug.solenopsis.sdk.vm.IVMState;


public class AntFactory {
		
	public static IVMState getConstructionLinkAnt(INodeDaemon d, String source) {
		IVMState state = d.getState("blatant-construction-link");
		state.getStack().storeGValue("$source", source);
		return state;
	}

	public static IVMState getDiscoveryAnt(INodeDaemon d) {
		IVMState state = d.getState("blatant-discovery");
		return state;
	}

	public static IVMState getOptimizationLinkAnt(INodeDaemon d, String source) {
		IVMState state = d.getState("blatant-optimization-link");
		state.getStack().storeGValue("$source", source);
		return state;
	}

	public static IVMState getPingAnt(INodeDaemon d, String source) {
		IVMState state = d.getState("blatant-ping");
		state.getStack().storeGValue("$source", source);
		return state;
	}

	public static IVMState getUnLinkAnt(INodeDaemon d, String source) {
		IVMState state = d.getState("blatant-unlink");
		state.getStack().storeGValue("$source", source);
		return state;
	}

	public static IVMState getUpdateNeighborsAnt(INodeDaemon d, String source, Long timestamp,
			List<String> neighbors) {
		IVMState state = d.getState("blatant-update-neighbors");
		state.getStack().storeGValue("$timestamp", timestamp);
		state.getStack().storeGValue("$source", source);
		state.getStack().storeGValue("$neighbors", neighbors);
		return state;
	}


}
