package opt.blatant;

import java.util.Collection;
import java.util.Hashtable;

public class NetworkSystem {
	
	private static Hashtable<String, BlatAntLogic> nodes = new Hashtable<String, BlatAntLogic>();
	
	public static void addNode(BlatAntLogic n) {
		nodes.put(n.getIdentifier(), n);
	}
	
	public static void removeNode(String id) {
		nodes.remove(id);
	}

	public static BlatAntLogic getNode(String n) {
		return nodes.get(n);
	}

	public static int getNodeCount() {
		return nodes.size();
	}

	public static Collection<? extends String> getNodes() {
		return nodes.keySet();
	}

	public static int getEdgeCount() {
		int edges = 0;
		for (BlatAntLogic n : nodes.values())
			edges += n.getNeighborsCount();
		return edges;
	}
	
	public static int getIsolatedCount() {
		int isolated = 0;
		for (BlatAntLogic n : nodes.values()) {
			if (n.getNeighborsCount() == 0) {
				isolated++;
			}
		}
		return isolated;
	}

}
