/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package services;

import java.util.List;

import com.fuzzbug.solenopsis.sdk.exe.INodeDaemon;
import com.fuzzbug.solenopsis.sdk.plugins.BasicPlugin;
import com.fuzzbug.solenopsis.sdk.vm.IVM;

public class NodeDaemonProxy extends BasicPlugin {
	
	public NodeDaemonProxy(INodeDaemon d) {
		super("node", "Amos Brocco", "Plugin for accessing some data on the node daemon", "1.0", true);
		registerMethods();
	}
	
	public Object apply_setProperty(INodeDaemon node, IVM vm,
			List<Object> args) throws Exception {
		if (args.size() != 2) return false;
		String key = (String) args.get(0);
		Object value = args.get(1);
		node.setProperty(key, value);
		return value;
	}
	
	public Object apply_getProperty(INodeDaemon node, IVM vm,
			List<Object> args) throws Exception {
		if (args.size() != 1) return false;
		String key = (String) args.get(0);
		return node.getProperty(key);
	}

}
