/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package util;

import java.util.List;
import java.util.Map;
import java.util.Stack;

public class Dolly {
	
	@SuppressWarnings({ "unchecked" })
	public static Object deepClone(Object o) throws Exception {
		if (o instanceof Stack) {
			Stack<Object> l = (Stack<Object>) o.getClass().newInstance();
			Stack origin = (Stack) o;
			for(Object item : origin) {
				l.add(deepClone(item));
			}
			return l;
		} if (o instanceof List) {
			List<Object> l = (List<Object>) o.getClass().newInstance();
			List origin = (List) o;
			for(Object item : origin) {
				l.add(deepClone(item));
			}
			return l;
		} else if (o instanceof Map) {
			Map<String,Object> m = (Map<String, Object>) o.getClass().newInstance();
			Map<String,Object> origin = (Map<String,Object>) o;
			for(String key : origin.keySet()) {
				m.put(new String(key), deepClone(origin.get(key)));
			}
			return m;
		} else if (o instanceof String) {
			return new String((String) o);
		} else if (o instanceof Integer) {
			return new Integer((Integer)o);
		} else if (o instanceof Float) {
			return new Float((Float)o);
		} else if (o instanceof Boolean) {
			return new Boolean((Boolean)o);
		} else
			return o;
	}
	

}
