/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package com.fuzzbug.solenopsis.sdk.exe;

import com.fuzzbug.solenopsis.sdk.vm.IVM;

public interface IVMScheduler {
	
	/**
	 * Returns the number of current running VM
	 * @return	Number of VM
	 */
	public int getScheduleLength();

	/**
	 * Launches a virtual machine
	 * @param vm	Virtual machine to run
	 */
	public void schedule(IVM vm);

	/**
	 * Removes a virtual machine
	 * @param vm	Virtual machine to be removed
	 */
	public void unschedule(IVM vm);

}
