/**
 *  This file is part of
 *  
 *  Solenopsis 2: A Framework for the Development of Ant Algorithms
 *  
 *  Copyright (C) 2006-2009 Amos Brocco <amos.brocco@unifr.ch>
 *  						Pervasive and Artificial Intelligence Research Group
 *  						Department of Informatics DIUF
 *  						University of Fribourg, Fribourg
 *  						Switzerland
 *
 *  Solenopsis 2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  Solenopsis 2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with Solenopsis 2.  If not, see <http://www.gnu.org/licenses/>.
 *  
 */
package com.fuzzbug.solenopsis.sdk.vm;

import com.fuzzbug.solenopsis.sdk.softthreading.ISoftThread;

public interface IVM extends ISoftThread {

	/**
	 * Returns the state object
	 * @return	State object
	 */
	public IVMState getState();

	/**
	 * Returns the stack object
	 * @return	Stack object
	 */
	public IVMStack getStack();

	/**
	 * Returns the code object
	 * @return	Code object
	 */
	public IVMCode getCode();
	
	/**
	 * Returns the current program counter
	 * @return	Program counter
	 */
	public int getPC();

	/**
	 * Changes the current program counter
	 * @param value	New program counter value
	 */
	public void setPC(int value);
	
	public String getIdentifier();

}
